import re
import httplib
import urlparse
import urllib2
from BeautifulSoup import BeautifulSoup

def get_image_url(url):
    if url.endswith((".jpg",".png",".jpeg",".gif")):
        #print "direct img link found"
        return url

    real_url = unshorten_url(url)
    #print "unshortend "+real_url
    if real_url.endswith((".jpg",".png",".jpeg",".gif")):
        #print "shortend direct img link found"
        return real_url

    try:
        html = urllib2.urlopen(real_url)
    except IOError, e:
        return None
    
    data = html.read().decode('ascii','ignore')
    html.close()

    return extract_image(data)

def extract_image(html):
    image_pattern = re.compile('content=\"(.+?)(\".*)')
    
    soup = BeautifulSoup(html, fromEncoding="utf-8")
    #find Thumbnail MetaTag
    imgs = soup.findAll(property="og:image")
    if len(imgs) == 0:
        imgs = soup.findAll('img')
        #find Twitter Picture url
        image_pattern = re.compile('large media-slideshow-image.+src=\"(.+?)(\".*)')

    img_url = None
    for img in imgs:
        match = image_pattern.search(str(img))
        if match:
            img_url = match.group(1)
            #print img_url

    return img_url

def unshorten_url(url):
    parsed = urlparse.urlparse(url)
    h = httplib.HTTPConnection(parsed.netloc)
    h.request('HEAD', parsed.path)
    response = h.getresponse()
    if response.status/100 == 3 and response.getheader('Location'):
        return response.getheader('Location')
    else:
        return url
